package com.ybxiang.nms.simpleclient;

import java.util.Hashtable;
import java.util.Properties;

import javax.naming.Context;

import org.jboss.ejb.client.ContextSelector;
import org.jboss.ejb.client.EJBClientConfiguration;
import org.jboss.ejb.client.EJBClientContext;
import org.jboss.ejb.client.PropertiesBasedEJBClientConfiguration;
import org.jboss.ejb.client.remoting.ConfigBasedEJBClientContextSelector;
import org.jboss.naming.remote.client.InitialContextFactory;

import com.ybxiang.nms.server.ejb.session.ISecuredRemoteSession;

public class RemoteEJBClient_ear {

    public static void main(String[] args) throws Exception {
        invokeStatelessBean();
    }

    private static void invokeStatelessBean() throws Exception {
        // Let's lookup the remote stateless calculator
        final ISecuredRemoteSession statelessRemoteCalculator = lookupRemoteStatelessCalculator();
        System.out.println("Obtained a remote stateless calculator for invocation");
        // invoke on the remote calculator
        int a = 204;
        int b = 340;
        System.out.println("Adding " + a + " and " + b + " via the remote stateless calculator deployed on the server");
        int sum = statelessRemoteCalculator.add(a, b);
        System.out.println("Remote calculator returned sum = " + sum);
        if (sum != a + b) {
            throw new RuntimeException("Remote stateless calculator returned an incorrect sum " + sum + " ,expected sum was " + (a + b));
        }
        // try one more invocation, this time for subtraction
        int num1 = 3434;
        int num2 = 2332;
        System.out.println("Subtracting " + num2 + " from " + num1 + " via the remote stateless calculator deployed on the server");
        int difference = statelessRemoteCalculator.subtract(num1, num2);
        System.out.println("Remote calculator returned difference = " + difference);
        if (difference != num1 - num2) {
            throw new RuntimeException("Remote stateless calculator returned an incorrect difference " + difference + " ,expected difference was " + (num1 - num2));
        }
    }
    
    private static ISecuredRemoteSession lookupRemoteStatelessCalculator() throws Exception {
    	return lookupRemoteStatelessCalculator_WithoutPropertieFile_method2_ear();//ear
    }
    
	private static ISecuredRemoteSession lookupRemoteStatelessCalculator_WithoutPropertieFile_method2_ear() throws Exception {		
		//String jndiName = "ejb:/nms-server-ear/nms-server-ejb/SecuredRemoteSession!" + ISecuredRemoteSession.class.getName();//ear
		String jndiName = "java:/nms-server-ear/nms-server-ejb/SecuredRemoteSession!" + ISecuredRemoteSession.class.getName();//ear
		
		// fetch the Properties somehow (depending on user application's requirement)
		final Properties p = new Properties();//ǿԴļȡҲԼ죡
		{
			p.put(Context.INITIAL_CONTEXT_FACTORY, InitialContextFactory.class.getName());
			p.put(Context.PROVIDER_URL, "remote://192.168.1.100:4447/");
			//p.put(InitialContext.SECURITY_PRINCIPAL, "testX");
			//p.put(InitialContext.SECURITY_CREDENTIALS, "test1234");
			p.put("jboss.naming.client.ejb.context", "true");
			p.put("jboss.naming.client.connect.options.org.xnio.Options.SASL_POLICY_NOPLAINTEXT", "false");
		}
		
		// Create a EJB client configuration from the properties
		final EJBClientConfiguration ejbClientConfiguration = new PropertiesBasedEJBClientConfiguration(p);
		 
		// EJB client context selection is based on selectors. So let's create a ConfigBasedEJBClientContextSelector which uses our EJBClientConfiguration created in previous step
		final ContextSelector<EJBClientContext> ejbClientContextSelector = new ConfigBasedEJBClientContextSelector(ejbClientConfiguration);
		
		// Now let's setup the EJBClientContext to use this selector
		final ContextSelector<EJBClientContext> previousSelector = EJBClientContext.setSelector(ejbClientContextSelector);
		
		// Now that we have setup the EJB client context (backed by our client configuration and receiver information), 
		// let's now do the JNDI lookup and invoke on the proxies
		final Hashtable props = new Hashtable();
		// setup the ejb: namespace URL factory
		props.put(Context.URL_PKG_PREFIXES, "org.jboss.ejb.client.naming");
		final Context context = new javax.naming.InitialContext(props);
		 
		 
		return (ISecuredRemoteSession)context.lookup(jndiName);
	}
	
}
